#include "stdafx.h"

#include <CodeGenerator.h>


void CodeGenerator::ResolveExitSubSchedule()
{
	BOOST_FOREACH( long exitSubCodePosition, exitSubCodePositions )
	{
		pNativeCode->Overwrite( exitSubCodePosition, (long)( pNativeCode->GetSize()-(exitSubCodePosition+sizeof(long)) ) );
	}
	
	// TODO: 
	BOOST_FOREACH( long exitSubCodePositionOld, _exitSubCodePositions_ObpOld )
	{
		extern int obp;
		pNativeCode->OverwriteOld( exitSubCodePositionOld, (long)( obp-(exitSubCodePositionOld+sizeof(long)) ) );
	}
}

void CodeGenerator::CheckUnresolveSchedule()
{
	if( pertialSchedules.size() > 0 )
	{
		SetError();
	}
}


// ֘A
void CodeGenerator::opfix_JmpPertialSchedule( const PertialSchedule *pPertialSchedule )
{
	bool isSuccessful = false;

	PertialSchedules::iterator it = pertialSchedules.begin();
	while( it != pertialSchedules.end() )
	{
		if( (*it) == pPertialSchedule )
		{
			long newValue = pNativeCode->GetSize() - (pPertialSchedule->GetCodePos()+pPertialSchedule->GetTypeSize());

			extern int obp;
			long newValueOld = obp - (pPertialSchedule->GetObpOld()+pPertialSchedule->GetTypeSize());

			if( pPertialSchedule->GetTypeSize() == sizeof(char) )
			{
				if( newValue < -128 || 127 < newValue )
				{
					// ͈͊O
					SetError();
				}

				pNativeCode->Overwrite( pPertialSchedule->GetCodePos(), (char)newValue );

				// TODO: ipȂj
				pNativeCode->OverwriteOld( pPertialSchedule->GetObpOld(), (char)newValueOld );
			}
			else if( pPertialSchedule->GetTypeSize() == sizeof(long) )
			{
				pNativeCode->Overwrite( pPertialSchedule->GetCodePos(), newValue );

				// TODO: ipȂj
				pNativeCode->OverwriteOld( pPertialSchedule->GetObpOld(), newValueOld );
			}
			else
			{
				SetError();
			}

			it = pertialSchedules.erase( it );
			delete pPertialSchedule;

			isSuccessful = true;
		}
		else
		{
			it++;
		}
	}

	if( isSuccessful == false )
	{
		SetError();
	}
}
const PertialSchedule *CodeGenerator::__jmp_op_format( char opcode, long offset, int op_size, bool isPertialSchedule, bool isSelfOpcodeOffset )
{
	long beginCodePos = pNativeCode->GetSize();
	{
		// TODO: 
		extern int obp;
		beginCodePos = obp;
	}

	if( opcode == (char)0xEB )
	{
		// jmp߂̂Ƃ
		if( op_size == sizeof(char) )
		{
			pNativeCode->Put( (char)opcode );
		}
		else if( op_size == sizeof(long) )
		{
			pNativeCode->Put( (char)0xE9 );
		}
		else
		{
			SetError();
		}
	}
	else
	{
		if( op_size == sizeof(char) )
		{
			pNativeCode->Put( (char)((char)0x70 | opcode) );
		}
		else if( op_size == sizeof(long) )
		{
			pNativeCode->Put( (char)0x0F );
			pNativeCode->Put( (char)((char)0x80 | opcode) );
		}
		else
		{
			SetError();
		}
	}

	const PertialSchedule *pPertialSchedule = NULL;
	if( isPertialSchedule )
	{
		pertialSchedules.push_back( new PertialSchedule( pNativeCode->GetSize(), op_size ) );
		pPertialSchedule = pertialSchedules[pertialSchedules.size()-1];
	}

	if( isSelfOpcodeOffset )
	{
		// g̖߃TCYlꍇ
		//offset += ( pNativeCode->GetSize() - beginCodePos ) + op_size;

		// TODO: 
		extern int obp;
		offset -= ( obp - beginCodePos ) + op_size;
	}

	if( op_size == sizeof(char) )
	{
		pNativeCode->Put( (char)offset );
	}
	else if( op_size == sizeof(long) )
	{
		pNativeCode->Put( offset );
	}
	else
	{
		SetError();
	}

	return pPertialSchedule;
}
const PertialSchedule *CodeGenerator::op_jle( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x0E, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jbe( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x06, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jge( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x0D, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jae( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x03, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jl( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x0C, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jb( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x02, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jg( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x0F, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_ja( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x07, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jne( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x05, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_je( long offset, int op_size, bool isPertialSchedule )
{
	return __jmp_op_format( (char)0x04, offset, op_size, isPertialSchedule );
}
const PertialSchedule *CodeGenerator::op_jmp( long offset, int op_size, bool isPertialSchedule, bool isSelfOpcodeOffset )
{
	return __jmp_op_format( (char)0xEB, offset, op_size, isPertialSchedule, isSelfOpcodeOffset );
}
void CodeGenerator::op_jmp_continue()
{
	//op_jmp( GetContinueCodePos()-(pNativeCode->GetSize()+sizeof(long)), sizeof(long) );

	// TODO: iOpBuffer/obpp~L̃R[hLɂׂj

	if( GetContinueCodePosOld() == -1 )
	{
		SetError(12,"Continue",cp);
		return;
	}

	extern int obp;
	op_jmp( GetContinueCodePosOld()-obp, sizeof(long), false, true );
}
void CodeGenerator::op_jmp_exitsub()
{
	// IyR[h
	pNativeCode->Put( (char)0xE9 );

	exitSubCodePositions.push_back( pNativeCode->GetSize() );
	
	extern int obp;
	_exitSubCodePositions_ObpOld.push_back( obp );

	pNativeCode->Put( (long)0 );
}
void CodeGenerator::op_jmp_goto_schedule( const GotoLabelSchedule &gotoLabelSchedule )
{
	// IyR[h
	pNativeCode->Put( (char)0xE9 );

	gotoLabelSchedules.push_back( gotoLabelSchedule );

	pNativeCode->Put( (long)0 );
}
